import java.rmi.*;
import java.rmi.server.*;
import javax.rmi.ssl.*;

public class HelloServer extends UnicastRemoteObject implements Hello {

    public HelloServer() throws RemoteException {
		super(0, new RMISSLClientSocketFactory(),
		 	     new RMISSLServerSocketFactory());
    }

    public String sayHello() {
		System.out.println("HelloServer called");
		return "Hello World!";
    }

    public static void main(String args[]) {
		// Create and install a security manager
	    System.setSecurityManager(new RMISecurityManager());

		try {
		    HelloServer obj = new HelloServer();

		    // Registrieren beim Namensdienst
		    Naming.rebind("rmi://localhost/HelloServer", obj);
		    System.out.println("HelloServer registered");
		} catch (Exception e) {
		    System.out.println("Exception: " + e.getMessage());
		    e.printStackTrace();
		}
    }
}
